#ifndef _COLORSPACE_H_
#define _COLORSPACE_H_

#include "impr.h"

struct rgb {
	u8 *r, *g, *b;
};
struct hsv {
	u8 *h, *s, *v;
};
struct yrg {
	u8 *y, *r, *g;
};

void cs_rgb2hsv(struct hsv *hsv, const struct rgb *rgb, int size);
void cs_hsv2rgb(struct rgb *rgb, const struct hsv *hsv, int size);

void cs_rgb2yrg(struct yrg *yrg, const struct rgb *rgb, int size);
void cs_yrg2rgb(struct rgb *rgb, const struct yrg *yrg, int size);

void cs_chan2rgb(struct rgb *rgb, const u8* chan, int size);

void cs_rgb2argb_buf(u32 *buf, const struct rgb *rgb, int size);
void cs_argb_buf2rgb(struct rgb *rgb, const u32 *buf, int size);
void cs_rgb2abgr_buf(u32 *buf, const struct rgb *rgb, int size);
void cs_abgr_buf2rgb(struct rgb *rgb, const u32 *buf, int size);

#endif /* _COLORSPACE_H_ */
