#ifndef _QUEUE_H_
#define _QUEUE_H_

#include <assert.h>
#include <stdlib.h>

struct queue {
	int start, len;
	int nel;
	int data[0];
};

static inline struct queue *queue_new(int nel)
{
	struct queue *q = malloc(sizeof(*q) + nel*sizeof(int));
	q->start = 0;
	q->len = 0;
	q->nel = nel;
	return q;
}

static inline void enqueue(struct queue *q, int el)
{
	assert(q->len < q->nel);
	q->data[(q->start + q->len++) % q->nel] = el;
}

static inline int dequeue(struct queue *q)
{
	int el;
	assert(q->len > 0);
	el = q->data[q->start++];
	q->start %= q->nel;
	q->len--;
	return el;
}

static inline int queue_empty(struct queue *q)
{
	return q->len == 0;
}

static inline void queue_free(struct queue *q)
{
	free(q);
}

#endif /* _QUEUE_H_ */
