#ifndef _SEGMENTIZE_H_
#define _SEGMENTIZE_H_

#include "impr.h"

int segmentize_4(u16 *region_mask, b8 *chan, int w, int h);
int segmentize_8(u16 *region_mask, b8 *chan, int w, int h);


/**
 * segmentize
 * @region_mask: returned regions, [x]=0 for border, numbers enumerate
 * 	regions
 * @chan: segmentize this; [x]=0 are considered borders, 1 region parts
 * @w: image width
 * @h: image height
 * @connectedness: 4 or 8-connected
 *
 * Performs 4 or 8-connected region segmentation.
 * Returns number of regions, with 0 to that number in @region_mask.
 */
static inline int segmentize(u16 *region_mask, b8 *chan,
		int w, int h, int connectedness)
{
//dbg("region_mask:%p, chan:%p, w:%i, h:%i, conn:%i\n", region_mask, chan, w, h, connectedness);
	assert(connectedness == 4 || connectedness == 8);
	if (connectedness == 4)
		return segmentize_4(region_mask, chan, w, h);
	else
		return segmentize_8(region_mask, chan, w, h);
}

#endif /* _SEGMENTIZE_H_ */
